#include "player.h"
#include "csrpg2.h"

Actor* CGame::findPlayerActor() {
	/*
		A cheap function to go through and find the first actor in the pile marked with the "Plyr"
		designation, and then pass them into the player pointer so that they may be controlled by the human.
	 
		This has additional benefits later; you might want to reassign the player's control to an NPC, for
		example (to make Steve the Bartender kill Mordo the Great at the very last minute).
	*/
	list <Actor*>::iterator it;
	for(it = actorList.begin(); it != actorList.end(); it++) {
		Actor *te = *it;
		if(te->conversation[0] == "Plyr") {
			return te;
		}
	}
	return NULL;
}