#ifndef _DEFINES_H_
#define _DEFINES_H_

/// PLATFORM DEPENDENT CRAP
#define LINE_SIZE 401

/// INTERFACE STATES -- CONTROLS WHAT METHOD THE MAIN GAME ENGINE HANDS OFF TO
// In a menu, like inventory or stats or game controls
#define MODE_INMENU 0
// In an item shop
#define MODE_INSHOP 1
// In a fight
#define MODE_INFIGHT 2

/// MAX VARIABLES -- HOW MANY OF WHAT DO WE NEED (for ASSETS ONLY)?
#define MAX_CHARS 9
#define MAX_ICONS 29
#define MAX_TILES 47
#define MAX_ITEMS 32
#define MAX_FLAGS 40
#define MAX_SOUNDS 14

/// ITEM FLAGS
#define ITEM_INACTIVE 0
#define ITEM_WEAPON 1
#define ITEM_HEALING 2
#define ITEM_BEER 3
#define ITEM_ARMOR 4
#define ITEM_DEAD 5
#define ITEM_KEYS 6
#define ITEM_MANA 7
#define ITEM_BOW 8
#define ITEM_FLOATER 9
#define ITEM_PICK 10
#define ITEM_ROOMKEY 11
#define ITEM_GIFT 12

/// ICON DEFINIES
#define ICON_HIT 9
#define ICON_MISSED 10
#define ICON_HPBAR 16
#define ICON_MPBAR 17
#define ICON_FIREBALL 18
#define ICON_CASINO 19
#define ICON_HEALFX 20
#define ICON_BULLET 21
#define ICON_HEARTEMPTY 22
#define ICON_HEARTFULL 23
#define ICON_MANAEMPTY 24
#define ICON_MANAFULL 25
#define ICON_BATTLEON 26
#define ICON_CRITICALHIT 28

/// MAPS
#define MAPWIDTH 350
#define MAPHEIGHT 350

/// ANIMATION
#define ANIMATION_STEP 185

/// GAMESTATS
#define PLAYER_SPEED 250
#define SHOT_SPEED 300

/// HUD
#define GUI_COLOR_RED 0
#define GUI_COLOR_GREEN 0
#define GUI_COLOR_BLUE 100

#endif
