#include "csrpg2.h"

/*
	This file contains the extremely rudimentary fight AI.
 
	It is a REAL MESS so please avoid making changes to it.
*/

void CGame::fightAI(Actor *actor, Actor *target) {
	// First, try to attack the player
	if(((int)distance(actor->x,actor->y,target->x,target->y)/48) < 2) {
		// ATTACKING
		// FUTURE ADDITION: Roll this out into a separate function
		// Okay, I can hit
		int maxDmg = 1;
		// Ehhhh. They ALWAYS attack with their fists.
		string result = "Enemy attacking with fists";
		vars.fightMsgVec.push_back(result);
		char *outcome = new char[50];
		// OK, take a roll and plus it with your str
		Uint32 attackRoll = (rand() % maxDmg) + actor->stats.strength;
		int armour_save = 0;
		if(target == player) {
			// Absorb the hit with your armour
			if(fvars.playerArmour) {
				armour_save = fvars.playerArmour->maxEffect;
			}
		}
		// Do the defensive roll, incorporating the armour save
		Uint32 defenseRoll = ((rand() % target->stats.dexterity) + armour_save);
		attackRoll -= defenseRoll;
		if(attackRoll < defenseRoll) {
			// Obviously, if you defended better than they attacked, it is hard for them to get through
			sprintf(outcome,"Missed!");
			fightEffectAt(target->x, target->y, ICON_MISSED, "Miss");
		} else {
			// Decrement the health from the owned PC/NPC
			if(attackRoll < 0) {
				// Armour saves actually healed you before wtf
				attackRoll = 0;
			}
			target->stats.hp -= attackRoll;
			sprintf(outcome,"Hit for %i damage",attackRoll);
			// Play the "thwack" noise
			playSound(1);
			// Print out the roll on a "hit!" icon
			char *num = new char[40];
			sprintf(num,"%i",attackRoll);
			fightEffectAt(target->x, target->y, ICON_HIT, num);
			delete[] num;
		}
		string s_outcome = outcome;
		vars.fightMsgVec.push_back(s_outcome);
		delete[] outcome;
		return; // Bail out
	}
	// Okay, that failed. Let's try to move closer to the player
	if(fightAIMove(actor,target) < 0) {
		// OK, can't attack then, can't move. Damn!
		string s_outcome = "Can't reach you!";
		vars.fightMsgVec.push_back(s_outcome);
		printf("Can't reach you!?\n");
		vars.bYourTurn = true;
		return;
	}
}

int CGame::fightAIMove(Actor* actor, Actor *target) {
	float orig_x = actor->x;
	float orig_y = actor->y;
	if(target->x < actor->x) {
		if(!theMap->isSolid(actor->x - 48, actor->y)) {
			if(!combatCollide(actor,target,-48,0)) {
				actor->x -= 48;
				actor->direction = 3;
			}
		}
	}
	else if(target->x > actor->x) {
		if(!theMap->isSolid(actor->x + 48, actor->y)) {
			if(!combatCollide(actor,target,48,0)) {
				actor->x += 48;
				actor->direction = 1;
			}
		}
	}
	if(target->y < actor->y) {
		if(!theMap->isSolid(actor->x, actor->y - 48)) {
			if(!combatCollide(actor,target,0,-48)) {
				actor->y -= 48;
				actor->direction = 0;
			}
		}
	}
	else if(target->y > actor->y) {
		if(!theMap->isSolid(actor->x, actor->y + 48)) {
			if(!combatCollide(actor,target,0,48)) {
				actor->y += 48;
				actor->direction = 2;
			}
		}
	}
	if(orig_x == actor->x && orig_y == actor->y) {
		return -1;
	} else {
		return 0;
	}
}

void CGame::updateBullet() {
	if(!fvars.bIsStillShooting) {
		/*fvars.shot_x = player->x + 24;
		fvars.shot_y = player->y + 24;*/
		return;
	}
	if(fvars.shot_x < enemy->x) {
		fvars.shot_x += SHOT_SPEED * vars.timer_delta;
	}
	else if(fvars.shot_x > enemy->x) {
		fvars.shot_x -= SHOT_SPEED * vars.timer_delta;
	}
	if(fvars.shot_y < enemy->y) {
		fvars.shot_y += SHOT_SPEED * vars.timer_delta;
	}
	else if(fvars.shot_y > enemy->y) {
		fvars.shot_y -= SHOT_SPEED * vars.timer_delta;
	}
	if(distance(fvars.shot_x,fvars.shot_y,enemy->x,enemy->y) < 30) {
		printf("Got him.\n");
		fvars.bIsStillShooting = false; // Hit!
	}
	// Draw the bullet, relative to player.
	SDL_Rect drawRect;
	drawRect.x = ((SCREEN_WIDTH/2)-48) - (Sint16)((player->x)-(fvars.shot_x));
	drawRect.y = 252 - (Sint16)((player->y)-(fvars.shot_y));
	SDL_BlitSurface(art.icons[ICON_BULLET],NULL,screen,&drawRect);
}