#include "csrpg2.h"

void CGame::fightPanel() {
	/*
		Draws the "battle!!" panel on screen
		Could probably be used anywhere in the game, but why would you want to?
	 
		Usually executed when an enemy spots you & initiates battle.
	*/
	bool bDone = false;
	bool bRaising = true;
	bool bFalling = false;
	float staytimer = 1000.0f;
	float y = 600.0f;
	SDL_Rect rect = {0,0,0,0};
	rect.x = (SCREEN_WIDTH-(art.icons[ICON_BATTLEON]->w))/2;
	while(!bDone) {
		// Draw map and shit
		rect.y = (Sint16)y;
		vars.timer_start = SDL_GetTicks();
		drawMap();
		drawSprites();
		if(bRaising) {
			y -= (400 * vars.timer_delta);
			if(y <= (600 - (art.icons[ICON_BATTLEON]->h))/2) {
				bRaising = false;
			}
		}
		else if(bFalling) {
			y += (400 * vars.timer_delta);
			if(y > 600) {
				bDone = true;
			}
		}
		else {
			staytimer -= vars.timer_elapsed;
			if(staytimer <= 0) {
				bFalling = true;
			}
		}
		SDL_BlitSurface(art.icons[ICON_BATTLEON],NULL,screen,&rect);
		vars.timer_elapsed = SDL_GetTicks() - vars.timer_start;
		vars.timer_delta = vars.timer_elapsed / 1000.0f;
		while(SDL_PollEvent(&event)) {
			if(event.type == SDL_KEYDOWN) {
				if(!bFalling && !bRaising) {
					bFalling = true;
				}
			}
		}
		SDL_Flip(screen);
		SDL_Delay(0);
	}
	vars.timer_elapsed = 0.0f;
}