#include "csrpg2.h"
#include <cstdio>

/*
	main.cpp
	Holds the main function and passes off control to the game program as soon as possible.
	This is where we will put some of our initialization code, but most will go in the CGame()
	constructor.
*/

int main(int argc, char *argv[]) {
	printf("initializing...\n");
	CGame *theGame = new CGame();
	theGame->begin();
	while(theGame->bPleaseLoadGame) {
		delete theGame;
		theGame = new CGame();
		theGame->begin();
	}
	delete theGame;
	return 0;
}

void CGame::loadAndStart(char *dir) {
	loadGame(dir);
	gameLoop();
}