#include "player.h"

/*
	Constructors and related function definitions for the players minus serialization
*/

/*Player::Player() {
	stats.hp = 25;
	stats.hp_max = 25;
	stats.mp = 10;
	stats.mp_max = 10;
	stats.xp = 0;
	stats.level = 1;
	stats.strength = 4;
	stats.dexterity = 4;
	stats.intelligence = 4;
	sprite = 0;
	direction = 2;
}*/

Actor::Actor() {
	x = 0;
	y = 0;
	stats.hp = 0;
	stats.hp_max = 0;
	stats.mp = 0;
	stats.mp_max = 0;
	stats.xp = 0;
	stats.level = 0;
	stats.strength = 0;
	stats.dexterity = 0;
	stats.intelligence = 0;
	flagId = -1;				/// We need error checking for this
	bIsHostile = 0;
	bIsWanderer = 0;
	sprite = 0;
	direction = 0;
	walkFrame = 0;
	frameTimer = 0;
	conversation[0] = "I'm unset";
	conversation[1] = "Still unset";
	myName = "Unset Actor";
	wtimer = 0;
	bIsEnraged = false;
	wdir = 0;
}

void Actor::animate(float delta) {
		frameTimer += delta;
		if(frameTimer > ANIMATION_STEP) {
			frameTimer = 0;
			walkFrame++;
			if(walkFrame > 2) {
				walkFrame = 0;
			}
		}
}
