#include "csrpg2.h"

void CGame::findSleep() {
	// Sleep is necessary to defeat hangovers, and regain lost HP.
	// Five out of ten doctors agree, it's the best way to kick ass.
	int tx = (int)(player->x / 48);
	int ty = (int)(player->y / 48);
	for(int r = ty - 1; r <= ty + 1; r++) {
		for(int c = tx - 1; c <= tx + 1; c++) {
			// scan for a bed.
			if((theMap->getTileAt(c,r) == 6 || theMap->getTileAt(c,r) == 7)) {
				printf("px = %i,%i checking = %i,%i\n",tx,ty,c,r);
				if(!theMap->isSolid(tx,ty)) {
					// Found a bed!
					vars.talkTimer = TALK_TIMER;
					vars.currentTalk = "Good night...";
					player->stats.hp = player->stats.hp_max;	// Health ++ 
					player->stats.mp = player->stats.mp_max;
					// Sleepy stuff
					float i = 0;
					SDL_Rect bar;
					bar.x = 10;
					bar.y = 500;
					bar.h = 55;
					bar.w = 200;
					while(i < 100) {
						vars.timer_start = SDL_GetTicks();
						// Draw the sleepy screen
						SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0,0,0));
						SDL_FillRect(screen,&bar,SDL_MapRGB(screen->format,100,100,100));
						if(vars.drunkenness > 0) {
							drawTextAt("Sleeping it off...",10,480);
						} else {
							drawTextAt("Napping...",10,480);
						}
						//barWidth += (int)((80) * vars.timer_delta);
						i += (80)*vars.timer_delta;
						bar.w = (Uint16)(i * 2);
						SDL_FillRect(screen,&bar,SDL_MapRGB(screen->format,GUI_COLOR_RED,GUI_COLOR_GREEN,GUI_COLOR_BLUE));
						SDL_Flip(screen);
						SDL_Delay(0);
						vars.frames++;
						while(SDL_PollEvent(&event)) {
							if(event.type == SDL_KEYDOWN) {
								if(event.key.keysym.sym == SDLK_ESCAPE) {
									return;
								}
							}
						}
						vars.timer_elapsed = SDL_GetTicks() - vars.timer_start;
						vars.timer_delta = vars.timer_elapsed / 1000.0f;
					}
					vars.timer_start = SDL_GetTicks();
					vars.timer_elapsed = 0;
					vars.timer_delta = 0;
					vars.drunkenness = 0;						// Bang, no longer drunk.
					return;
				}
			}
		}
	}
	vars.talkTimer = TALK_TIMER;
	vars.currentTalk = "Can't sleep here. Find a bed";
}