#include <cstring>
#include "SDL_ttf.h"
#include "editor.h"

string MapEditor::getUserString(const char *askFor, int x, int y) {
	bool bDone = false;
	SDL_Rect textRect = {0,0,0,0};
	textRect.x = x;
	textRect.y = y + 20;
	textRect.h = 20;
	textRect.w = 500;
	string inputString = "";
	while(!bDone) {
		drawTextAt(askFor,x,y);
		SDL_FillRect(screen,&textRect,SDL_MapRGB(screen->format,0,0,0));
		drawTextAt(inputString.c_str(),x,(y+20));
		while(SDL_PollEvent(&event)) {
			if(event.type == SDL_KEYDOWN) {
				if((event.key.keysym.sym >= SDLK_a && event.key.keysym.sym <= SDLK_z) || event.key.keysym.sym == SDLK_SPACE
					|| (event.key.keysym.sym >= SDLK_0 && event.key.keysym.sym <= SDLK_9)) {
					char addOn = (char)event.key.keysym.unicode;
					inputString += addOn;
				}
				else if(event.key.keysym.sym == SDLK_BACKSPACE) {
					inputString.clear();
				}
				else if(event.key.keysym.sym == SDLK_RETURN) {
					return inputString;
				}
			}
			else if(event.type == SDL_QUIT) {
				exit(0);
			}
		}
		SDL_Flip(screen);
		SDL_Delay(0);
	}
	return "False";
}