#include "vars.h"
#include "SDL_mixer.h"
#include "defines.h"

AudioAssets::AudioAssets() {
	if(Mix_OpenAudio(22050,AUDIO_S16,2,4096)) {
		fprintf(stderr,"Could not initialize audio\n");
	}
	printf("Loading audio\n");
	bSoundOff = false;
	for(int i = 0; i < MAX_SOUNDS; i++) {
		char *fname = new char[60];
		sprintf(fname,"data/assets/sounds/%i.wav",i);
		sfx[i] = Mix_LoadWAV(fname);
		if(sfx[i]) {
			printf("\tLoaded %s successfully\n",fname);
		}
		delete[] fname;
	}
}