#include "csrpg2.h"
#include "SDL_image.h"

void CGame::deathScreen() {
	/*
		When you die, this is the screen that pops up.
		It, uh, sucks.
	 
		Can't think of a way to make it better, either.
	*/
	bool bDone = false;
	SDL_Surface *gameOver = IMG_Load("data/assets/gameover.png");
	if(!gameOver) {
		fprintf(stderr,"data/assets/gameover.png missing\n");
		exit(1);
	}
	SDL_Surface *temp = SDL_DisplayFormatAlpha(gameOver);
	SDL_FreeSurface(gameOver);
	gameOver = temp;
	SDL_Rect rect;
	rect.x = (SCREEN_WIDTH - gameOver->w) / 2;
	rect.y = (600 - gameOver->h) / 2; // centre the image
	rect.w = gameOver->w;
	rect.h = gameOver->h;
	while(!bDone) {
		SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0,0,0));
		SDL_BlitSurface(gameOver,NULL,screen,&rect);
		drawTextAt("You have perished in your quest...",10,600 - returnTextHeight());
		while(SDL_PollEvent(&event)) {
			if(event.type == SDL_KEYDOWN || event.type == SDL_QUIT) {
				bDone = true;
			}
		}
		SDL_Flip(screen);
		SDL_Delay(0);
	}
	bPlayingGame = false;
	bMustQuit = true;
	vars.timer_start = SDL_GetTicks();
	vars.timer_elapsed = 0;
	vars.timer_delta = 0;
	bPleaseLoadGame = true;
}