#include "csrpg2.h"

/*
	This file controls the fight log and other HUD functionality. It is somewhat
	of a mess.
*/

void CGame::drawFightConsole() {
	int drawn = 0;
	unsigned int i = vars.fightMsgVec.size() - 1;
	int y = 540;
	for(drawn = 0; drawn < 5; drawn++) {
		y = 540 - drawn*returnTextHeight();
		if(i >= 0 && i < vars.fightMsgVec.size()) {
			// Blow text to screen
			drawTextAt(vars.fightMsgVec[i].c_str(),10,y);
		}
		i--;
	}
	//SDL_Delay(10); // DEBUG
}

void CGame::drawFightHUD() {
	if(vars.bYourTurn) {
		// Draw hotkeys and logo
		drawTextAt("Weapons:",10,2);
		// Draw all weapons
		int j = 0;
		for(int i = (fvars.weapons.size() - 1); i >= 0; i--) {
			// Draw the list of weapons
			char *str = new char[200];
			char type = 'M';
			if(fvars.weapons[i]->type == ITEM_BOW) {
				type = 'R';
			}
			sprintf(str,"%s %i max dmg %c",fvars.weapons[i]->itemName.c_str(),(fvars.weapons[i]->maxEffect+player->stats.strength),type);
			drawTextAt(str,20,j*returnTextHeight() + 20);
			delete[] str;
			if(i == fvars.selectedWeapon) {
				// Draw a little hand icon next to the currently selected item.
				SDL_Rect rect;
				rect.x = 0;
				rect.y = j * returnTextHeight() + 20;
				SDL_BlitSurface(art.icons[0],NULL,screen,&rect);
			}
			j++;
		}
		// Draw the icons for combat, if they pick attack and there are no weapons in their inventory
		// then just attack with fists (max dmg: 2)
		SDL_Rect iconRect;
		iconRect.x = (SCREEN_WIDTH - (5*48))/2;
		iconRect.y = 10;
		if(!fvars.bMenuOpen) {
			for(int i = 0; i < 5; i++) {
				SDL_BlitSurface(art.icons[4+i],NULL,screen,&iconRect);
				iconRect.x += 48;
			}
		} else {
			for(int i = 0; i < 5; i++) {
				SDL_BlitSurface(art.icons[11+i],NULL,screen,&iconRect);
				iconRect.x += 48;
			}
		}
		// Under the icons, draw our health bar!
		float health = player->stats.hp;
		float healthm = player->stats.hp_max;
		float healthp = (health/healthm)*120;
		int healthBarFilled = (int)healthp;
		float magich = player->stats.mp;
		float magicm = player->stats.mp_max;
		float magicp = (magich/magicm)*120;
		int magicBarFilled = (int)magicp;
		SDL_Rect Bar;
		Bar.h = 16;
		Bar.w = 120;
		Bar.x = SCREEN_WIDTH - 120;
		Bar.y = 600 - 32;
		SDL_Rect barPercent = {0,0,0,0};
		// Danger: POTENTIALLY SLOW TO DO ALL OF THIS CRAP
		barPercent.h = 16;
		SDL_FillRect(screen,&Bar,SDL_MapRGB(screen->format,0,0,0));
		barPercent.w = healthBarFilled;
		// Draw health bar
		SDL_BlitSurface(art.icons[ICON_HPBAR],&barPercent,screen,&Bar);
		Bar.y += 16;
		Bar.w = 120;
		// Draw magic bar
		SDL_FillRect(screen,&Bar,SDL_MapRGB(screen->format,0,0,0));
		barPercent.w = magicBarFilled;
		SDL_BlitSurface(art.icons[ICON_MPBAR],&barPercent,screen,&Bar);
	}
	// Draw the fight effects
	if(!fvars.bIsStillShooting || enemy->stats.hp < 1) {
		drawFightEffects();
	}
	// Draw the console
	drawFightConsole();
	//delete[] str;
}
