#ifndef _FIGHTVARS_H_
#define _FIGHTVARS_H_

#include "item.h"
#include "fEffect.h"
#include <vector>
#include <list>
using namespace std;

/*
	Various variables needed only when in a fight situation.
	They include a bunch of poofy one-off variables to make the fight effects look good.
*/

class FightVars {
	public:
	int selectedWeapon;
	int menuSelection;
	bool bMenuOpen;
	bool bIsStillShooting;
	float shot_x;
	float shot_y; // For the shooting animation
	Item* playerArmour;
	vector <Item*> weapons;
	float movetimer;
	int scroll; // For the weapon list
	list <fightEffect*> effects;
	FightVars();
};

#endif