#include "csrpg2.h"

#define ODDS 4

char* CGame::gamblingMadLibs() {
	//string gamblingOn;
	char *towns[] = {"North Haverbrook","Townsville","Commie City","Bartertown",
							"Milkshop","Toy Town","Firetruck Rocketship","Crackton",
							"South Slumville","Albany"};
	char *stuff[] = {"chicken catching","random number generators","giant robot fights",
							"local bar brawls","children's music recitals","Fruitbat mating",
							"broken printers","minority cable TV","elevator racing",
							"your GPA","premature optimization","llama farming contests"};
	char *str = new char[200];
	sprintf(str,"You are gambling on %s in %s",stuff[rand()%12],towns[rand()%10]);
	return str;
}

void CGame::gambleLoop() {
	/*
		Pop up the gambling screen
		Offer a variety of ways to gamble
		Let the player bet at variable odds
		Give them their money
		Let them go
	*/
	bool bDoneGambling = false;
	char *oddstxt = new char[40];
	sprintf(oddstxt,"Today's odds: 1/%i",ODDS);
	char *money = new char[100];
	//sprintf(money,"Your cash: %i",player->stats.money);
	char *yourbet = new char[100];
	unsigned int bet = 0;
	char *outcome = new char[100];
	sprintf(outcome,"You haven't bet yet...");
	char *gamblingon = gamblingMadLibs();
	SDL_Rect ravcinoRect = {0,0,0,0};
	while(!bDoneGambling) { 
		// Draw the HUD stuff, including:
		// - Your current bet
		// - The odds
		// - The name of the freaking casino
		// - The result of the last time you bet (or nothing if you haven't bet yet)
		SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,GUI_COLOR_RED,GUI_COLOR_GREEN,GUI_COLOR_BLUE));
		SDL_BlitSurface(art.icons[ICON_CASINO],NULL,screen,&ravcinoRect);
		drawTextAt(oddstxt,0,returnTextHeight()*2);
		sprintf(money,"Your cash: $%i",player->stats.money);
		drawTextAt(money,0,600-returnTextHeight());
		sprintf(yourbet,"$%i",bet);
		centreTextAt(yourbet,300);
		centreTextAt(gamblingon,300-(returnTextHeight()*2));
		centreTextAt("Your current bet:",300-returnTextHeight());
		centreTextAt("Press left and right to change bet, enter to bet, escape to leave",300+returnTextHeight());
		centreTextAt("Press up to set your maximum bet, down to reset",300+(returnTextHeight()*2));
		centreTextAt(outcome,300+(returnTextHeight()*3));
		// Do input
		while(SDL_PollEvent(&event)) {
			if(event.type == SDL_QUIT) {
				bDoneGambling = true;
			}
			else if(event.type == SDL_KEYDOWN) {
				if(event.key.keysym.sym == SDLK_ESCAPE) {
					bDoneGambling = true;
				}
				else if(event.key.keysym.sym == SDLK_RETURN) {
					// Okay, wants to gamble.
					if(bet > 0) {
						// Make your bet
						player->stats.money -= bet;
						// Now let chance take over
						if(rand() % ODDS == 0) {
							// Great, you won.
							sprintf(outcome,"You won $%i!!!",ODDS*bet);
							// Give them money paid out at the odds.
							player->stats.money += ODDS*bet;
						}
						else {
							// Nope, they lost. Suckers.
							sprintf(outcome,"Sorry, you lost $%i",bet);
						}
						bet = 0;
						delete[] gamblingon; // ALWAYS BE SAFE
						gamblingon = gamblingMadLibs();
					}
				}
				else if(event.key.keysym.sym == SDLK_F3) {
					SDL_SaveBMP(screen,"gambling.bmp");
				}
			}
		}
		Uint8 *keystate = SDL_GetKeyState(NULL);
		if(keystate[SDLK_LEFT]) {
			// Increment bet in small amounts
			if(bet > 0) {
				bet--;
				SDL_Delay(10);
			}
		}
		else if(keystate[SDLK_RIGHT]) {
			// Decrement bet in small amounts
			if(bet < player->stats.money) {
				bet++;
				SDL_Delay(10);
			}
		}
		else if(keystate[SDLK_UP]) {
			// Bet it all, big spender.
			bet = player->stats.money;
		}
		else if(keystate[SDLK_DOWN]) {
			// Bet nothing at all.
			bet = 0;
		}
		// Wait
		SDL_Flip(screen);
		SDL_Delay(0);
	}
	delete[] money;
	delete[] gamblingon;
	delete[] outcome;
	delete[] yourbet;
	delete[] oddstxt;
	vars.timer_start = SDL_GetTicks();
	vars.timer_delta = 0;
	vars.timer_elapsed = 0;
}