#include "csrpg2.h"
#include <fstream>
/*
std::ifstream TheInputFileG;
std::ofstream TheOutputFileG;

int readNumberFromFileG() {
	
	char *line = new char[40];
	TheInputFileG.getline(line,LINE_SIZE,'\n');
	return atoi(line);
}

string readStringFromFileG() {
	
	char *line = new char[40];
	TheInputFileG.getline(line,LINE_SIZE,'\n');
	string result = line;
	return result;
}

void writeStringToFileG(string enter) {

	TheOutputFileG << enter.c_str();
	TheOutputFileG << "\n";
}

void writeNumberToFileG(int number) {

	TheOutputFileG << number;
	TheOutputFileG << "\n";
}*/

void CGame::saveGame(char *dir) {
	/*
		Save the game to file.
	*/
	char *path = new char[60];
	sprintf(path,"%s/vars.sav",dir);
	vars.serializeTo(path);
	saveActors(dir);
	saveItems(dir);
	saveQuests(dir);
	delete[] path;
	theMap->saveMap(dir);
}

int CGame::loadGame(char *dir) {
	/*
		Load the game from file. Also, this is the 5000th line added to CSRPG2. Hi mom!
	*/
	char *path = new char[60];
	sprintf(path,"%s/vars.sav",dir);
	if(vars.serializeFrom(path)!=0) {
		fprintf(stderr,"Save game nonexistant at %s\n",path);
		return -1; // Dump back out to the game menu
	}
	loadActors(dir);
	loadItems(dir);
	loadQuests(dir);
	//gameLoop(); // Begin the game loop, and then dump back out to the menu, now unnecessary.
	theMap->loadMap(dir);
	player = findPlayerActor();
	delete[] path;
	if(player) {
		return 0; // ok
	}
	return 1; // cracked... faulty.
}