#include "csrpg2.h"

string CGame::inputLoop() {
	bool bDoneHere = false;
	string input;
	//int i = 0;
	while(!bDoneHere) {
		int i = 0;
		SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,GUI_COLOR_RED,GUI_COLOR_GREEN,GUI_COLOR_BLUE));
		drawTextAt("Type the name of the directory containing the custom game and hit enter:",10,10);
		drawTextAt(input.c_str(),10,25);
		while(SDL_PollEvent(&event)) {
			if(event.type == SDL_KEYDOWN) {
				if(event.key.keysym.sym >= SDLK_a && event.key.keysym.sym <= SDLK_z) {
					input += ((char)(event.key.keysym.sym));
					i++;
				} else if(event.key.keysym.sym == SDLK_BACKSPACE) {
					input.clear();
				}
				else if(event.key.keysym.sym == SDLK_RETURN) {
					vars.timer_elapsed = 0;
					vars.timer_delta = 0;
					vars.timer_start = SDL_GetTicks();
					printf("user input %s\n",input.c_str());
					//str = input.c_str();
					bDoneHere = true;
				}
			}
			if(event.type == SDL_QUIT || event.key.keysym.sym == SDLK_ESCAPE) {
				return NULL;
			}
		}
		vars.frames++;
		SDL_Flip(screen);
		SDL_Delay(0);
	}
	if(input.size() > 50) {
		return "data";
	} else {
		return input;
	}
}