#include "csrpg2.h"

#define KEY_RANGE 1

int CGame::unlockDoor(float x, float y, bool withPick, bool motelKey) {
	int tx = ((int)x/48);
	int ty = ((int)y/48);
	printf("I think you are at (%i,%i)\n",tx,ty);
	for(int y = (ty - KEY_RANGE); y <= (ty + KEY_RANGE); y++) {
		for(int x = (tx - KEY_RANGE); x <= (tx + KEY_RANGE); x++) {
			if(x < 0 || x >= MAPWIDTH || y < 0 || y >= MAPHEIGHT) {
				// uh oh, that will check off the map! skip this tile
				continue;
			}
			if((theMap->getTileAt(x,y) == 4 && !motelKey) || ((theMap->getTileAt(x,y) == 45 && !motelKey)) ||
			   (theMap->getTileAt(x,y) == 44 && motelKey) ) {
				if(withPick) {
					int result = rand() % 6;
					if(result == 2) {
						// Successful lock picking
						playSound(8);
						theMap->setTileAt(x,y,3);
						return 1;
					}
					else if(result == 0 && !vars.bCheatPick) {
						// Critically failed lock picking (picks destroyed)
						playSound(13);
						return 2;
					}
					else {
						// Failed lock picking
						playSound(12);
						return 3;
					}
				}
				playSound(8);
				theMap->setTileAt(x,y,3);
				return 1;
			}
		}
	}
	return 0;
}